//
// eda.c
//
// step response EDA
//    9600 baud FTDI interface
//
// Eyal Perry
// 11/04/19
//
// (c) Massachusetts Institute of Technology 2010
// This work may be reproduced, modified, distributed,
// performed, and displayed for any purpose. Copyright is
// retained and must be preserved. The work is provided
// as is; no warranty is provided, and users accept all
// liability.
//

#include <avr/io.h>
#include <util/delay.h>
#include "ws2812_config.h"
#include "light_ws2812.h"

#define output(directions,pin) (directions |= pin) // set port direction for output
#define input(directions,pin) (directions &= (~pin)) // set port direction for input
#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin

#define led_port PORTA
#define led_direction DDRA
#define led (1 << PA3)

struct cRGB color[2];

int main(void) {
   //
   // main
   //
   static unsigned char intensity = 0;
   int direction = 1;
   //
   // set clock divider to /1
   //
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
   // initialize LEDs
   output(led_direction, led);
   set(led_port, led);
   //
   // main loop
   //
   while (1) {
     // NeoPixel
     color[0].r=0;color[0].g=0;color[0].b=intensity;    // Write red to array
     color[1].r=0;color[1].g=0;color[1].b=intensity;
     ws2812_setleds(color,2);
     _delay_ms(10);

     if (intensity == 255) {
       direction = -1;
     } else if (intensity == 0) {
       direction = 1;
     }
     intensity += direction;
    }
 }
